//+------------------------------------------------------------------+
//|                                                    ComplexON.mq4 |
//|                               Copyright  2010, Dodonov Vitalii. |
//|                                       http://www.mql_5@fxmail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Dodonov Vitalii."
#property link      "http://www.mql_5@fxmail.ru"
#include <WinUser32.mqh>

//   ----- ,        !!!!!!!!!!!!!! 

//---- input parameters
extern double    Lot=0.01;       // 
extern int       LotMod=2;       //  
//extern double    percent=0.05;   //  5$  20$ =0.3;              //     ,      1 . 
                                 //  20$  30$ =0.2; 
                                 //  30$  40$ =0.2; 
                                 //  40$  50$ =0.12; 
                                 //  50$  60$ =0.1; 
                                 //  60$  70$ =0.1; 
                                 //  70$  80$ =0,08;
                                 //  80$  90$ =0.07;
                                 //  90$  100$ =0.06;
                                 //  100$  1000$ =0.05;
                                 //  1000$  10000$ =0.03;
                                 //  10 000$  100 000$ =0.01;
                                 //  100 000$   =0,005; 
 
extern double    Risk1=5.0;      //   >= 10000$
extern double    Risk2=10.0;     //   >=100$  <10000$
extern int       Slippage=1;     // 
extern int       Spred=4;        //     
extern int       MaxOpen=5;      //    
extern int       TrailingStop_normal=30; //  - 
extern int       TrailingStop_middle=20; 
extern int       Loss_null_normal=30; //      
extern int       Loss_null_middle=15; //        
extern int       punkt=3;             // - ,     - 
extern int       tp_pr=20;            //      TakeProfit,        
extern int       bar_mod=5;           // - ,     / . 
extern int       TakeProfit_normal=50; // TakeProfit  
extern int       TakeProfit_middle=30; // TakeProfit   

extern string    mcd="//=========================//";
extern int       MACD_EMA_fast=5;
extern int       MACD_EMA_slow=34;
extern int       MACD_SMA=5;
extern int       MACD_Price=4;
extern int       RSI_period=14;
extern int       RSI_price=4;
extern int       CCI_period=21;
extern int       CCI_price=4; 
extern string    mcd1="//========================//";
extern string    mas="//=========================//";
extern int       p_ma1=233;
extern int       p_ma2=89;
extern int       p_ma3=21;
extern string    mas1="//========================//"; 
extern int       period=13; 
extern string    obb="//=========================//";
extern int       obbi_period=21;
extern string    obb1="//=======================//";
extern bool      TimeGM=true;
extern int       Hours=2; 
extern string    take="========================//";
extern bool      prof=true;
extern int       FI_period=21;
extern int       FI_method=0;
extern int       FI_price=4;     
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
 string symbols=Symbol();
 double ASK=MarketInfo(symbols,MODE_ASK);
 double BID=MarketInfo(symbols,MODE_BID);
 double SPREAD=MarketInfo(symbols,MODE_SPREAD);
 double LEVEL=MarketInfo(symbols,MODE_STOPLEVEL); //    
 int    TYPE=OrderType();
 int    TOTAL=OrdersTotal();

//=======================================     ============================//
 double   Lot_m;
 double   Stoploss;
 bool     stop_trade=false;
 datetime dttime;
 double   dtlots;
 int      dttype;
 bool     dtprofit;
 double   percent;

 /*for (int n = 0; n < OrdersHistoryTotal(); n++) {
     if( OrderSelect(n, SELECT_BY_POS, MODE_HISTORY)){
      if (dttime < OrderCloseTime()) {
         dttime = OrderCloseTime();
         dtlots = OrderLots();
         dttype = OrderType();
         if (OrderProfit() >= 0.0){ dtprofit = true;}else{ dtprofit = false;}
      }
   }
   }*/
   
 if(Risk1<=0 || Risk1>100){Risk1=10;}
 if(Risk2>5 || Risk2<=0){Risk2=5;}
 if(LotMod>3 || LotMod<0){LotMod=0;}

 if(AccountFreeMargin()>=5 && AccountFreeMargin()<20){percent=0.3;}
 if(AccountFreeMargin()>=20 && AccountFreeMargin()<40){percent=0.2;}
 if(AccountFreeMargin()>=40 && AccountFreeMargin()<50){percent=0.12;}
 if(AccountFreeMargin()>=50 && AccountFreeMargin()<70){percent=0.1;}
 if(AccountFreeMargin()>=70 && AccountFreeMargin()<80){percent=0.08;}
 if(AccountFreeMargin()>=80 && AccountFreeMargin()<90){percent=0.07;}
 if(AccountFreeMargin()>=90 && AccountFreeMargin()<100){percent=0.06;}
 if(AccountFreeMargin()>=100 && AccountFreeMargin()<1000){percent=0.05;}
 if(AccountFreeMargin()>=1000 && AccountFreeMargin()<10000){percent=0.03;}
 if(AccountFreeMargin()>=10000 && AccountFreeMargin()<100000){percent=0.01;}
 if(AccountFreeMargin()>=100000){percent=0.005;} 

 switch(LotMod){

 case 0: Lot_m=Lot; Stoploss=(AccountFreeMargin()*percent*0.1*Point)/Lot_m; break;

 case 1: if(AccountFreeMargin()>=10000){ Lot_m=NormalizeDouble( (AccountFreeMargin()/1000)*(Risk1/100),0); }
         if(AccountFreeMargin()>=1000 && AccountFreeMargin()<10000){Lot_m=NormalizeDouble( (AccountFreeMargin()/1000)*(Risk2/100),1);}
         if(AccountFreeMargin()>=100 && AccountFreeMargin()<1000){Lot_m=NormalizeDouble( (AccountFreeMargin()/1000)*(Risk2/100),2);}
         if(AccountFreeMargin()>=50 && AccountFreeMargin()<100){Risk2=20.0; Lot_m=NormalizeDouble( (AccountFreeMargin()/1000)*(Risk2/100),2);}
         if(AccountFreeMargin()>=40 && AccountFreeMargin()<50){Risk2=30.0; Lot_m=NormalizeDouble( (AccountFreeMargin()/1000)*(Risk2/100),2);}
         if(AccountFreeMargin()>=30 && AccountFreeMargin()<40){Risk2=40.0; Lot_m=NormalizeDouble( (AccountFreeMargin()/1000)*(Risk2/100),2);}
         if(AccountFreeMargin()>=20 && AccountFreeMargin()<30){Risk2=50.0; Lot_m=NormalizeDouble( (AccountFreeMargin()/1000)*(Risk2/100),2);}
         if(AccountFreeMargin()>=10 && AccountFreeMargin()<20){Risk2=100.0; Lot_m=NormalizeDouble( (AccountFreeMargin()/1000)*(Risk2/100),2);}
         if(AccountFreeMargin()<10){stop_trade=true;}else{stop_trade=false;}
         Stoploss=(AccountFreeMargin()*percent*0.1*Point)/Lot_m; break;

 case 2: if(AccountFreeMargin()>=5 && AccountFreeMargin()<100){ Stoploss=(AccountFreeMargin()*percent*0.01)/10;}
         if(AccountFreeMargin()>=100 && AccountFreeMargin()<1000){Stoploss=(AccountFreeMargin()*percent*0.01)/NormalizeDouble( (AccountFreeMargin()*0.1),0);}
         if(AccountFreeMargin()>=1000 && AccountFreeMargin()<10000){Stoploss=(AccountFreeMargin()*percent*0.02)/NormalizeDouble( (AccountFreeMargin()*0.1),0);}
         if(AccountFreeMargin()>=10000 && AccountFreeMargin()<100000){Stoploss=(AccountFreeMargin()*percent*0.1)/NormalizeDouble( (AccountFreeMargin()*0.1),0);}
         if(AccountFreeMargin()>=100000){Stoploss=(AccountFreeMargin()*percent*0.5)/NormalizeDouble( (AccountFreeMargin()*0.1),0);}
         Lot_m=(AccountFreeMargin()*percent*0.1*Point)/Stoploss; break;  
        
/* case 3: if(dtprofit==true){Lot_m=Lot; Stoploss=(AccountFreeMargin()*percent*0.1*Point)/Lot_m;}else{Lot_m=2*dtlots; Stoploss=(AccountFreeMargin()*percent*0.1*Point)/Lot_m;}
         if(Lot_m<0.01){Lot_m=0.01;}
         if(Lot_m>200.0){Lot_m=200.0;} 
         break;*/             
}  
//=========================================================================================================================================//
//
//
//======================================================         ==============================//

 bool asian,euro,american,as_eu,eu_amer;
 datetime GMT=TimeHour(TimeCurrent())-Hours;
 bool euro_pair,asian
 
 if(TimeGM==true){
 if(GMT>=0 && GMT<=9){asian=true;}else{asian=false;}
 if(GMT>=6 && GMT<=15){euro=true;}else{euro=false;}
 if(GMT>=13 && GMT<=22){american=true;}else{american=false;}
 if(GMT>=6 && GMT<=9){as_eu=true; euro=false; asian=false;}else{as_eu=false;}
 if(GMT>=13 && GMT<=15){eu_amer=true; euro=false; american=false;}else{eu_amer=false;}
 } 
  bool Asian_Pair,Euro_Pair,American_Pair;
  
  if(SYMBOLS=="NZDUSD" || SYMBOLS=="AUDJPY" || SYMBOLS=="USDJPY" || SYMBOLS=="EURJPY" || SYMBOLS=="GBPJPY"){Asian_Pair=true;}else{Asian_Pair=false;}
  if(SYMBOLS=="AUDUSD" || SYMBOLS=="EURUSD" || SYMBOLS=="GBPUSD" || SYMBOLS=="EURJPY" || SYMBOLS=="USDJPY" || SYMBOLS=="USDCHF" || SYMBOLS=="GBPCHF"){Euro_Pair=true;}else{Euro_Pair=false;}
  if(SYMBOLS=="NZDUSD" || SYMBOLS=="AUDUSD" || SYMBOLS=="USDJPY" || SYMBOLS=="EURUSD" || SYMBOLS=="USDCAD" || SYMBOLS=="USDCHF" || SYMBOLS=="GBPUSD"){American_Pair=true;}else{American_Pair=false;}
  
 bool timeEnter; 
  
  switch(Period()){
  
  case PERIOD_M1: if(TimeSeconds(TimeCurrent())>=40){timeEnter=true;}else{timeEnter=false;}break;
  case PERIOD_M5: if((TimeMinute(TimeCurrent())==4 || TimeMinute(TimeCurrent())==9 || TimeMinute(TimeCurrent())==14 || TimeMinute(TimeCurrent())==19 
                   || TimeMinute(TimeCurrent())==24 || TimeMinute(TimeCurrent())==29 || TimeMinute(TimeCurrent())==34 || TimeMinute(TimeCurrent())==39
                   || TimeMinute(TimeCurrent())==44 || TimeMinute(TimeCurrent())==49 || TimeMinute(TimeCurrent())==54 || TimeMinute(TimeCurrent())==59)
                   && TimeSeconds(TimeCurrent())>=40){timeEnter=true;}else{timeEnter=false;}break;
  case PERIOD_M15: if((TimeMinute(TimeCurrent())==14 || TimeMinute(TimeCurrent())==29 || TimeMinute(TimeCurrent())==44 || TimeMinute(TimeCurrent())==59)
                       && TimeSeconds(TimeCurrent())>=40){timeEnter=true;}else{timeEnter=false;}break;
  case PERIOD_M30: if((TimeMinute(TimeCurrent())==29 || TimeMinute(TimeCurrent())==59)&& TimeSeconds(TimeCurrent())>=40){timeEnter=true;}else{timeEnter=false;}break;
  case PERIOD_H1: if(TimeMinute(TimeCurrent())==59 && TimeSeconds(TimeCurrent())>=40){timeEnter=true;}else{timeEnter=false;}break;
  case PERIOD_H4: if((TimeHour(TimeCurrent())==3 || TimeHour(TimeCurrent())==7 || TimeHour(TimeCurrent())==11 || TimeHour(TimeCurrent())==15
                   || TimeHour(TimeCurrent())==19 || TimeHour(TimeCurrent())==23)&& TimeMinute(TimeCurrent())==59 && TimeSeconds(TimeCurrent())>=40){
                   timeEnter=true;}else{timeEnter=false;}break;
  case PERIOD_D1: if(TimeHour(TimeCurrent())==23 && TimeMinute(TimeCurrent())==59 && TimeSeconds(TimeCurrent())>=40){timeEnter=true;}else{timeEnter=false;}break;                                                       
  
  }
  
//=========================================================================================================================================//
//
//
//
//=========================================================================================================================================//
//
//
//============================================  ==================================================================================//

 int counted_bars=IndicatorCounted();
 int i=Bars-counted_bars-1;
 int periodm=Period();
 bool MACup,MACdw,flat,trend_up,trend_dw;
 bool obbi_trend_up,obbi_trend_dw,obbi_trend_mid;
 double power_impuls;
 bool H_up,H_dw; 
 int signal_up,signal_dw, trend_global_up,trend_global_dw,trend_local_up,trend_local_dw,obbi_upp,
     obbi_dww,obbi_mmd,kan_up,kan_dw,kan_pb,kan_pm,mast_up,mast_dw,power_im_up,power_im_dw,ashi_up,ashi_dw,stat_up,stat_dw,
     total_up,total_dw;
 int timeframe; 
 double TakeProfit;
 double Pd,Ps;
  
  switch(periodm){
  case PERIOD_M1:  timeframe=PERIOD_M5; break;
  case PERIOD_M5:  timeframe=PERIOD_M30; break;
  case PERIOD_M15: timeframe=PERIOD_H1; break;
  case PERIOD_M30: timeframe=PERIOD_H4; break;
  case PERIOD_H1:  timeframe=PERIOD_H4; break;
  case PERIOD_H4:  timeframe=PERIOD_D1; break;
  case PERIOD_D1:  timeframe=PERIOD_W1; break;
  case PERIOD_W1:  timeframe=PERIOD_MN1; break; 
  }
  
     

 while(i>=0){


 double MAC1=iMACD(symbols,0,MACD_EMA_fast,MACD_EMA_slow,MACD_SMA,MACD_Price,MODE_MAIN,i);       
 double MAC2=iMACD(symbols,0,MACD_EMA_fast,MACD_EMA_slow,MACD_SMA,MACD_Price,MODE_MAIN,i+1);
 double MAC3=iMACD(symbols,0,MACD_EMA_fast,MACD_EMA_slow,MACD_SMA,MACD_Price,MODE_SIGNAL,i);
 double MAC4=iMACD(symbols,0,MACD_EMA_fast,MACD_EMA_slow,MACD_SMA,MACD_Price,MODE_SIGNAL,i+1);
 double RSIm=iRSI(symbols,0,RSI_period,RSI_price,i);                                             //   MACD
 double CCIm=iCCI(symbols,0,CCI_period,CCI_price,i);                                             //   MACD



 if( ((MAC1>MAC3 && MAC2<=MAC4) || (MAC1>0 && MAC2<0)) && RSIm>50 && CCIm>0 ){MACup=true; MACdw=false;    //   
 if((TimeMinute(TimeCurrent())==29 || TimeMinute(TimeCurrent())==59) && TimeSeconds(TimeCurrent())>=40)   //
 { PlaySound("alert.wav");}}                                                                              //

 if( ((MAC1<MAC3 && MAC2>=MAC4) || (MAC1<0 && MAC2>0)) && RSIm<50  && CCIm<0 ){MACdw=true; MACup=false;   //     
 if((TimeMinute(TimeCurrent())==29 || TimeMinute(TimeCurrent())==59) && TimeSeconds(TimeCurrent())>=40)   //
 {  PlaySound("alert.wav");}}                                                                             // 

 double H_Ashi=iCustom(symbols,0,"Heiken Ashi V",7,0,1,i);                                                // ,  
 if(H_Ashi==High[i]){H_up=true; H_dw=false;} if(H_Ashi==Low[i]){H_dw=true; H_up=false;}                  //  
                                                                                                         
                                                                                                         
                              //============================================================================//                                                                                                         
  
                             //========================    ==================//
    
    
  int ma_h=iHighest(symbols,0,MODE_HIGH,p_ma1,i);   // ma 1-  
  int ma_l=iLowest(symbols,0,MODE_LOW,p_ma1,i);     //
  double hg=(High[ma_h]+Low[ma_l])/2;            //
  
  int ma_h1=iHighest(symbols,0,MODE_HIGH,p_ma2,i);  // ma 2- 
  int ma_l1=iLowest(symbols,0,MODE_LOW,p_ma2,i);    //
  double lw=(High[ma_h1]+Low[ma_l1])/2;          //
  
  int ma_h2=iHighest(symbols,0,MODE_HIGH,p_ma3,i);  // ma 3- 
  int ma_l2=iLowest(symbols,0,MODE_LOW,p_ma3,i);    //
  double md=(High[ma_h2]+Low[ma_l2])/2;          //
  
  if(lw>hg){trend_up=true; trend_dw=false;}      //  
  if(lw<hg){trend_dw=true; trend_up=false;}      //  
  
  int ma_pp=iHighest(symbols,0,MODE_HIGH,p_ma3,i);
  int ma_pm=iLowest(symbols,0,MODE_LOW,p_ma3,i);
  
  double lw4=(High[ma_pp]+Low[ma_pm])/2;
  
  int ma_b=iHighest(symbols,0,MODE_HIGH,p_ma1,i+1);
  int ma_c=iLowest(symbols,0,MODE_LOW,p_ma1,i+1);
  
  double hg1=(High[ma_b]+Low[ma_c])/2;
  
  int ma_s=iHighest(symbols,0,MODE_HIGH,p_ma3,i+1);
  int ma_p=iLowest(symbols,0,MODE_LOW,p_ma3,i+1);
  
  double lw1=(High[ma_s]+Low[ma_p])/2;
  
  double rm=hg-lw4;
  double fm=hg1-lw1;
  
  if(rm==fm && hg==hg1 && lw4==lw1){flat=true;}else{flat=false;}     //       
  
  
                           //===================================================================================================// 

                           //================================== OBBI(One Bulish-Bearish Indicator)==============================//
                            
 double obbi_hg=High[iHighest(symbols,0,MODE_HIGH,obbi_period,i)];
 double obbi_hg1=High[iHighest(symbols,0,MODE_HIGH,obbi_period,i+1)];
 double obbi_lw=Low[iLowest(symbols,0,MODE_LOW,obbi_period,i)];
 double obbi_lw1=Low[iLowest(symbols,0,MODE_LOW,obbi_period,i+1)];
 double middle_price=(High[i]-Low[i])/2+Low[i];
 double middle_price1=(High[i+1]-Low[i+1])/2+Low[i+1];
 
 if( MAC1>0 && middle_price1<middle_price && (obbi_hg1-middle_price1)>(obbi_hg-middle_price) && (obbi_hg-obbi_lw)>=(obbi_hg1-obbi_lw1))
 {obbi_trend_up=true; obbi_trend_dw=false;}       //   -
 
 if( MAC1<0 && middle_price1>middle_price && (middle_price1-obbi_lw1)>(middle_price-obbi_lw) && (obbi_hg-obbi_lw)>=(obbi_hg1-obbi_lw1))
 {obbi_trend_dw=true; obbi_trend_up=false;}       //   - 

 if(obbi_trend_up!=true && obbi_trend_dw!=true){obbi_trend_mid=true;}else{obbi_trend_mid=false;}   //     .
 
                           //===================================================================================================//
                           
                           //================================  "" ================================================//
                           
 

double statbull,statbear,statbull1,statbear1;
double sumb1,sumb2,sumbb1,sumbb2;
double mm,ss,mm1,ss1;
bool bullup,bearup,pb,pm;
int pbull,pbear;

//---------------     
for(int j=0;j<=period;j++){
if(Close[j]>Open[j]){mm=Close[j]-Open[j];  sumb1=sumb1+mm; pbull++;}
if(Close[j]<Open[j]){ss=Open[j]-Close[j];  sumb2=sumb2+ss; pbear++;}
if(Close[j]==Open[j]){mm=0; ss=0; sumb1=sumb1+mm; sumb2=sumb2+ss;}
}
statbull=sumb1;
statbear=sumb2;
 

for(int g=1;g<=period+1;g++){
if(Close[g]>Open[g]){mm1=Close[g]-Open[g]; sumbb1=sumbb1+mm1;}
if(Open[g]>Close[g]){ss1=Open[g]-Close[g]; sumbb2=sumbb2+ss1;}
if(Close[g]==Open[g]){mm1=0; ss1=0; sumbb1=sumbb1+mm1; sumbb2=sumbb2+ss1;}
}
statbull1=sumbb1;
statbear1=sumbb2;

if( (statbull-statbull1)>(statbear-statbear1) ){bullup=true; bearup=false;}else{bullup=false; bearup=true;}
if(pbull>pbear){pb=true; pm=false;}
if(pbear>pbull){pm=true; pb=false;}

 //----------------------    
 
 double mastbull=sumb1/pbull;
 double mastbear=sumb2/pbear;
 
 bool Uper,Downer,Middup,Midddw;
 
if(statbull>statbear && bullup==true && pb==true && mastbull>mastbear){Uper=true; Downer=false; }
if(statbear>statbull && bearup==true && pm==true && mastbear>mastbull){Downer=true; Uper=false; }
if(Uper!=true && Downer!=true){ if(statbull>statbear && bearup==true){Middup=true; Midddw=false;}
                                if(statbear>statbull && bullup==true){Midddw=true; Middup=false;}
} 


                             //===================================================================================================//
                             
                             
                             //====================================== PriceImpuls =======================================//
                             
  int l;
double MC,Pw,sum;

if(MAC1>0){

for(l=0;l<MACD_SMA;l++){
 
 MC=MathAbs(iMACD(NULL,0,MACD_EMA_fast,MACD_EMA_slow,MACD_SMA,MACD_Price,MODE_MAIN,l))/MathAbs(iMACD(NULL,0,MACD_EMA_fast,MACD_EMA_slow,MACD_SMA,MACD_Price,MODE_SIGNAL,l));
sum=MC+sum;
}
power_impuls=sum/MACD_SMA; 
sum=0;
}

if(MAC1<0 ){

for(l=0;l<MACD_SMA;l++){
 
 MC=MathAbs(iMACD(NULL,0,MACD_EMA_fast,MACD_EMA_slow,MACD_SMA,MACD_Price,MODE_SIGNAL,l))/MathAbs(iMACD(NULL,0,MACD_EMA_fast,MACD_EMA_slow,MACD_SMA,MACD_Price,MODE_MAIN,l));
sum=MC+sum;
}
power_impuls=sum/MACD_SMA;
sum=0;
}                           
                                          //====================================================================//
                                          
                                          //====================    =============//
                                          
 if(MACup==true){signal_up=10; signal_dw=0;}                                                                    
 if(MACdw==true){signal_dw=10; signal_up=0;}
 if(MAC1>0){trend_local_up=10; trend_local_dw=0;}else{trend_local_dw=10; trend_local_up=0;}
 
  Pd=(High[iHighest(symbols,timeframe,MODE_HIGH,p_ma1,i)]+Low[iLowest(symbols,timeframe,MODE_LOW,p_ma1,i)])/2;
  Ps=(High[iHighest(symbols,timeframe,MODE_HIGH,p_ma3,i)]+Low[iLowest(symbols,timeframe,MODE_LOW,p_ma3,i)])/2;
 
 if(Ps>Pd){trend_global_up=10; trend_global_dw=-10;}
 if(Pd>Ps){trend_global_dw=10; trend_global_up=-10;}
 if(obbi_trend_up==true){obbi_upp=10; obbi_dww=0;}
 if(obbi_trend_dw==true){obbi_dww=10; obbi_upp=0;}
 if(obbi_trend_mid==true){obbi_mmd=5;}else{obbi_mmd=0;}
 if(statbull>statbear){stat_up=10; stat_dw=0;}else{stat_dw=10; stat_up=0;}
 if(bullup==true){kan_up=10; kan_dw=-5;}
 if(bearup==true){kan_dw=10; kan_up=-5;}
 if(pb==true){kan_pb=10; kan_pm=0;}
 if(pm==true){kan_pm=10; kan_pb=0;}
 if(mastbull>mastbear){mast_up=10; mast_dw=-5;}
 if(mastbear>mastbull){mast_dw=10; mast_up=-5;}
 if(power_impuls>1){power_im_up=10; power_im_dw=0; }else{power_im_dw=10; power_im_up=0;}
 if(H_up==true){ashi_up=10; ashi_dw=-5;}
 if(H_dw==true){ashi_dw=10; ashi_up=-5;}
 
 total_up = signal_up + trend_local_up + (trend_global_up) + obbi_upp + obbi_mmd + stat_up + (kan_up) + kan_pb + (mast_up) + power_im_up + (ashi_up);
 total_dw = signal_dw + trend_local_dw + (trend_global_dw) + obbi_dww + obbi_mmd + stat_dw + (kan_dw) + kan_pm + (mast_dw) + power_im_dw + (ashi_dw);
 
 
 //==========================================================  TakeProfit ====================================================//
 /*
 double FI_index=iCustom(symbols,0,"Force Index",FI_period,FI_method,FI_price,0,i);
 
 if(prof==true){
 if(MACup==true ){
 if(MathAbs(FI_index)>=0.001 && MathAbs(FI_index)<0.01){TakeProfit=NormalizeDouble( (Close[i]*FI_index)+Close[i],4);}
 if(MathAbs(FI_index)>=0.01 && MathAbs(FI_index)<0.1){TakeProfit=NormalizeDouble( Close[i]+(Close[i]*FI_index)/10,4);}
 if(MathAbs(FI_index)>=0.1 && MathAbs(FI_index)<1.0){TakeProfit=NormalizeDouble( Close[i]+(Close[i]*FI_index)/100,4);}
 if(MathAbs(FI_index)>=1.0){TakeProfit=NormalizeDouble( Close[i]+(Close[i]*FI_index)/500,4);}
 }
 
 if(MACdw==true){
 if(MathAbs(FI_index)>=0.001 && MathAbs(FI_index)<0.01){TakeProfit=NormalizeDouble( Close[i]-(Close[i]*FI_index),4);}
 if(MathAbs(FI_index)>=0.01 && MathAbs(FI_index)<0.1){TakeProfit=NormalizeDouble( Close[i]-(Close[i]*FI_index)/10,4);}
 if(MathAbs(FI_index)>=0.1 && MathAbs(FI_index)<1.0){TakeProfit=NormalizeDouble( Close[i]-(Close[i]*FI_index)/100,4);}
 if(MathAbs(FI_index)>=1.0){TakeProfit=NormalizeDouble( Close[i]-(Close[i]*FI_index)/500,4);}
 }
 }
 */
i--;
} 

 //===========================================================   ======================================================//  
 
 int SendOpenBuy,SendOpenSell;

 
 if(IsExpertEnabled()==true){
 if(IsTradeAllowed()==true){
 if(AccountBalance()>5.0 && stop_trade!=true){
 //---------------------------------------------------------------------------------------------------------------------------------//
 
 if(TimeGM==true){
 if(euro==true){
 if(timeEnter==true && Euro_Pair==true){
 
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,(ASK-Stoploss),ASK+(TakeProfit_normal*Point),"BUY",789,0,Green); return(0);}
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=50 && total_up<70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,(ASK-Stoploss),ASK+(TakeProfit_middle*Point),"BUY",123,0,Green);  return(0);}
 if(flat==true && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,ASK-((LEVEL+1)*Point),ASK+((LEVEL+1)*Point),"BUY",456,0,Green); return(0);}
 if(OrderSelect(SendOpenBuy,SELECT_BY_TICKET,MODE_TRADES)){int message1=MessageBox("   :"+OrderOpenPrice(),"!",IDOK);}else{int message2=MessageBox("  :"+GetLastError(),"!",IDOK);}
 
 
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,(BID+Stoploss),BID-(TakeProfit_normal*Point),"SELL",321,0,Red);  return(0);}
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=50 && total_dw<70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,(BID+Stoploss),BID-(TakeProfit_middle*Point),"SELL",654,0,Red); return(0);}
 if(flat==true && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,BID+((LEVEL+1)*Point),BID-((LEVEL+1)*Point),"SELL",987,0,Red);  return(0);}
 if(OrderSelect(SendOpenSell,SELECT_BY_POS,MODE_TRADES)){int message3=MessageBox("   :"+OrderOpenPrice(),"!",IDOK);}else{int message4=MessageBox("  :"+GetLastError(),"!",IDOK);}
 
 }
 }//if(euro............)
 
 if(asian==true){
 if(timeEnter==true && Asian_Pair==true){
 
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,(ASK-Stoploss),ASK+(TakeProfit_normal*Point),"BUY",789,0,Green); return(0);}
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=50 && total_up<70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,(ASK-Stoploss),ASK+(TakeProfit_middle*Point),"BUY",123,0,Green);  return(0);}
 if(flat==true && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,ASK-((LEVEL+1)*Point),ASK+((LEVEL+1)*Point),"BUY",456,0,Green); return(0);}
 if(OrderSelect(SendOpenBuy,SELECT_BY_TICKET,MODE_TRADES)){int message5=MessageBox("   :"+OrderOpenPrice(),"!",IDOK);}else{int message6=MessageBox("  :"+GetLastError(),"!",IDOK);}
 
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,(BID+Stoploss),BID-(TakeProfit_normal*Point),"SELL",321,0,Red); return(0);}
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=50 && total_dw<70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,(BID+Stoploss),BID-(TakeProfit_middle*Point),"SELL",654,0,Red); return(0);}
 if(flat==true && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,BID+((LEVEL+1)*Point),BID-((LEVEL+1)*Point),"SELL",987,0,Red);  return(0);}
 if(OrderSelect(SendOpenSell,SELECT_BY_POS,MODE_TRADES)){int message7=MessageBox("   :"+OrderOpenPrice(),"!",IDOK);}else{int message8=MessageBox("  :"+GetLastError(),"!",IDOK);}
 
 }
 
 }// if(asian..........)
 
 if(american==true){
 if(timeEnter==true && American_Pair==true){
 
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,(ASK-Stoploss),ASK+(TakeProfit_normal*Point),"BUY",789,0,Green);  return(0);}
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=50 && total_up<70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,(ASK-Stoploss),ASK+(TakeProfit_middle*Point),"BUY",123,0,Green);  return(0);}
 if(flat==true && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,ASK-((LEVEL+1)*Point),ASK+((LEVEL+1)*Point),"BUY",456,0,Green); return(0);}
 if(OrderSelect(SendOpenBuy,SELECT_BY_TICKET,MODE_TRADES)){int message9=MessageBox("   :"+OrderOpenPrice(),"!",IDOK);}else{int message10=MessageBox("  :"+GetLastError(),"!",IDOK);}
 
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,(BID+Stoploss),BID-(TakeProfit_normal*Point),"SELL",321,0,Red); return(0);}
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=50 && total_dw<70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,(BID+Stoploss),BID-(TakeProfit_middle*Point),"SELL",654,0,Red); return(0);}
 if(flat==true && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,BID+((LEVEL+1)*Point),BID-((LEVEL+1)*Point),"SELL",987,0,Red);  return(0);}
 if(OrderSelect(SendOpenSell,SELECT_BY_POS,MODE_TRADES)){int message11=MessageBox("   :"+OrderOpenPrice(),"!",IDOK);}else{int message12=MessageBox("  :"+GetLastError(),"!",IDOK);}
 
 }
 }// if(american.......)
 

 
 }// if(TimeGM.........)
 //-----------------------------------------------------------------------------------------------------------------------------------//
 else
 {
 if(timeEnter==true){
 
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,(ASK-Stoploss),ASK+(TakeProfit_normal*Point),"BUY",789,0,Green);  return(0);}
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=50 && total_up<70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,(ASK-Stoploss),ASK+(TakeProfit_middle*Point),"BUY",123,0,Green);  return(0);}
 if(flat==true && SPREAD<=Spred && TOTAL<MaxOpen && MACup==true && total_up>=70){SendOpenBuy=OrderSend(symbols,OP_BUY,Lot_m,ASK,Slippage,ASK-((LEVEL+1)*Point),ASK+((LEVEL+1)*Point),"BUY",456,0,Green); return(0);}
 if(OrderSelect(SendOpenBuy,SELECT_BY_TICKET,MODE_TRADES)){int message13=MessageBox("   :"+OrderOpenPrice(),"!",IDOK);}else{int message14=MessageBox("  :"+GetLastError(),"!",IDOK);}
 
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,(BID+Stoploss),BID-(TakeProfit_normal*Point),"SELL",321,0,Red);  return(0);}
 if(flat==false && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=50 && total_dw<70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,(BID+Stoploss),BID-(TakeProfit_middle*Point),"SELL",654,0,Red); return(0);}
 if(flat==true && SPREAD<=Spred && TOTAL<MaxOpen && MACdw==true && total_dw>=70){SendOpenSell=OrderSend(symbols,OP_SELL,Lot_m,BID,Slippage,BID+((LEVEL+1)*Point),BID-((LEVEL+1)*Point),"SELL",987,0,Red);  return(0);}
 if(OrderSelect(SendOpenSell,SELECT_BY_POS,MODE_TRADES)){int message15=MessageBox("   :"+OrderOpenPrice(),"!",IDOK);}else{int message16=MessageBox("  :"+GetLastError(),"!",IDOK);}
 
 }
 }
 
 
 
 
 
 
 //---------------------------------------------------------------------------------------------------------------------------------//
 }else{int message19=MessageBox(" !");}
 }else{int message18=MessageBox("  !"+"\n   ."+"\n -->-->\"\"","!",IDOK);}
 }else{int message17=MessageBox("  !"+"\n   ."+"\n -->--> \"\"","!",IDOK);}
 
 
 
 //================================================================================================================================================//
 //
 //
 //
 //============================================================    =========================================================//
 
 
 //--------------------- -   --------------------
 for(int u=0;u<=TOTAL;u++){
 if(OrderSelect(u,SELECT_BY_POS,MODE_TRADES)==true){
 
 if(OrderMagicNumber()==456){
 if(TimeCurrent()>=OrderOpenPrice()+10700 && TimeCurrent()<OrderOpenPrice()+10801){bool close=OrderClose(OrderTicket(),Lot_m,BID,Slippage,Aqua);
 if(close!=true){int message22=MessageBox("  "+"\n"+GetLastError(),"!",IDOK); } 
 return(0);}
 }
 
 if(OrderMagicNumber()==987){
 if(TimeCurrent()>=OrderOpenPrice()+10700 && TimeCurrent()<OrderOpenPrice()+10801){bool close1=OrderClose(OrderTicket(),Lot_m,ASK,Slippage,Pink);
 if(close!=true){int message21=MessageBox("  "+"\n"+GetLastError(),"!",IDOK); }
 return(0);}
 }
 
 }
 }
 //---------------------------   ------------------------
 



 //==========================================================   ===================================================================//
 
 double StopMod;
 double Loss_price;
 bool   Stoploss_modify;
 
 for(int p=0;p<=TOTAL;p++){
 
 if(OrderSelect(p,SELECT_BY_POS,MODE_TRADES)==true){
 
 //-------------   .  .---------------------
 if(OrderMagicNumber()==789 && TYPE==OP_BUY && symbols==Symbol()){
 
 if(OrderStopLoss()<OrderOpenPrice()){ if(ASK>OrderOpenPrice() && ASK<=OrderOpenPrice()+(Loss_null_normal*Point) )
 {StopMod=(Loss_null_normal*Point)/(OrderOpenPrice()-OrderStopLoss()); Loss_price=NormalizeDouble((ASK-OrderOpenPrice())/StopMod,4)+OrderStopLoss(); 
 if(OrderStopLoss()<Loss_price && (ASK-Loss_price)>((LEVEL+1)*Point)){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  m 789:",GetLastError());}}}} 
 
 if(OrderStopLoss()>=OrderOpenPrice()){if( (ASK-OrderStopLoss())>(punkt+TrailingStop_normal)*Point ){Loss_price=ASK-(TrailingStop_normal*Point);
 if(OrderStopLoss()<Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  n 789:",GetLastError());}}}}                                      
 
 if(OrderStopLoss()>OrderOpenPrice() && (TakeProfit-ASK)/Point<=tp_pr ){Loss_price=High[iHighest(symbols,0,MODE_HIGH,bar_mod,0)]-(tp_pr*Point);
 if(OrderStopLoss()<Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  o 789:",GetLastError());}}}                                      
 
 }
 //--------------------------------------------------------------------
 
 
 //------------   .     ---------
 if(OrderMagicNumber()==123 && TYPE==OP_BUY && symbols==Symbol()){
                                         
  if(OrderStopLoss()<OrderOpenPrice()){ if(ASK>OrderOpenPrice() && ASK<=OrderOpenPrice()+(Loss_null_middle*Point) )
 {StopMod=(Loss_null_middle*Point)/(OrderOpenPrice()-OrderStopLoss()); Loss_price=NormalizeDouble((ASK-OrderOpenPrice())/StopMod,4)+OrderStopLoss(); 
 if(OrderStopLoss()<Loss_price && (ASK-Loss_price)>(LEVEL+1)*Point){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  m 123:",GetLastError());}}}} 
 
 if(OrderStopLoss()>=OrderOpenPrice()){if( (ASK-OrderStopLoss())>(punkt+TrailingStop_middle)*Point){Loss_price=ASK-(TrailingStop_middle*Point);
 if(OrderStopLoss()<Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  n 123:",GetLastError());}}}}                                      
 
 if(OrderStopLoss()>OrderOpenPrice() && (TakeProfit-ASK)/Point<=tp_pr ){Loss_price=High[iHighest(symbols,0,MODE_HIGH,bar_mod,0)]-(15*Point);
 if(OrderStopLoss()<Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  o 123:",GetLastError());}}}                                      
                                       
 }
 //--------------------------------------------------------------------
 
 
 //----------   .   -------------------------
 if(OrderMagicNumber()==456 && TYPE==OP_BUY && symbols==Symbol()){
 
  if(OrderStopLoss()<OrderOpenPrice()){ if(ASK>OrderOpenPrice() && ASK<=OrderOpenPrice()+((LEVEL+1)*Point) )
 {StopMod=((LEVEL+1)*Point)/(OrderOpenPrice()-OrderStopLoss()); Loss_price=NormalizeDouble((ASK-OrderOpenPrice())/StopMod,4)+OrderStopLoss(); 
 if(OrderStopLoss()<Loss_price && (ASK-Loss_price)>(LEVEL+1)*Point){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  m 456:",GetLastError());}}}} 
 
 if(OrderStopLoss()>=OrderOpenPrice()){if( (ASK-OrderStopLoss())>(LEVEL+1)*Point){Loss_price=ASK-((LEVEL+1)*Point);
 if(OrderStopLoss()<Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  n 456:",GetLastError());}}}}                                      
 
 if(OrderStopLoss()>OrderOpenPrice() && (TakeProfit-ASK)/Point<=tp_pr ){Loss_price=High[iHighest(symbols,0,MODE_HIGH,bar_mod,0)]-((LEVEL+1)*Point);
 if(OrderStopLoss()<Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  o 456:",GetLastError());}}}
 
 }
 //---------------------------------------------------------------------
 
 
 //---------   .   -------------------------
 if(OrderMagicNumber()==321 && TYPE==OP_SELL && symbols==Symbol()){
 
  if(OrderStopLoss()>OrderOpenPrice()){ if(BID<OrderOpenPrice() && BID>=OrderOpenPrice()-(Loss_null_normal*Point) )
 {StopMod=(Loss_null_normal*Point)/(OrderStopLoss()-OrderOpenPrice()); Loss_price=OrderStopLoss()-NormalizeDouble((OrderOpenPrice()-BID)/StopMod,4); 
 if(OrderStopLoss()>Loss_price && (Loss_price-BID)>(LEVEL+1)*Point){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  m 321:",GetLastError());}}}} 
 
 if(OrderStopLoss()<=OrderOpenPrice()){if( (OrderStopLoss()-BID)>(punkt+TrailingStop_normal)*Point){Loss_price=BID+(TrailingStop_normal*Point);
 if(OrderStopLoss()>Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  n 321:",GetLastError());}}}}                                      
 
 if(OrderStopLoss()<OrderOpenPrice() && (BID-TakeProfit)/Point<=tp_pr ){Loss_price=Low[iLowest(symbols,0,MODE_HIGH,bar_mod,0)]+(tp_pr*Point);
 if(OrderStopLoss()>Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  o 321:",GetLastError());}}}
 
 }
 
 //---------------------------------------------------------------------
 
 
 //---------   .     -------------
 if(OrderMagicNumber()==654 && TYPE==OP_SELL && symbols==Symbol()){
 
   if(OrderStopLoss()>OrderOpenPrice()){ if(BID<OrderOpenPrice() && BID>=OrderOpenPrice()-(Loss_null_middle*Point) )
 {StopMod=(Loss_null_middle*Point)/(OrderStopLoss()-OrderOpenPrice()); Loss_price=OrderStopLoss()-NormalizeDouble((OrderOpenPrice()-BID)/StopMod,4); 
 if(OrderStopLoss()>Loss_price && (Loss_price-BID)>(LEVEL+1)*Point){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  m 654:",GetLastError());}}}} 
 
 if(OrderStopLoss()<=OrderOpenPrice()){if( (OrderStopLoss()-BID)>(punkt+TrailingStop_middle)*Point){Loss_price=BID+(TrailingStop_middle*Point);
 if(OrderStopLoss()>Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  n 654:",GetLastError());}}}}                                      
 
 if(OrderStopLoss()<OrderOpenPrice() && (BID-TakeProfit)/Point<=tp_pr ){Loss_price=Low[iLowest(symbols,0,MODE_HIGH,bar_mod,0)]+(15*Point);
 if(OrderStopLoss()>Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  o 654:",GetLastError());}}}
 
 }
 
 //---------------------------------------------------------------------
 
 
 //-------------   .   -----------------------
 if(OrderMagicNumber()==987 && TYPE==OP_SELL && symbols==Symbol()){
 
   if(OrderStopLoss()>OrderOpenPrice()){ if(BID<OrderOpenPrice() && BID>=OrderOpenPrice()-((LEVEL+1)*Point) )
 {StopMod=((LEVEL+1)*Point)/(OrderStopLoss()-OrderOpenPrice()); Loss_price=OrderStopLoss()-NormalizeDouble((OrderOpenPrice()-BID)/StopMod,4); 
 if(OrderStopLoss()>Loss_price && (Loss_price-BID)>(LEVEL+1)*Point){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  m 987:",GetLastError());}}}} 
 
 if(OrderStopLoss()<=OrderOpenPrice()){if( (OrderStopLoss()-BID)>(LEVEL+1)*Point){Loss_price=BID+((LEVEL+1)*Point);
 if(OrderStopLoss()>Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  n 987:",GetLastError());}}}}                                      
 
 if(OrderStopLoss()<OrderOpenPrice() && (BID-TakeProfit)/Point<=tp_pr ){Loss_price=Low[iLowest(symbols,0,MODE_HIGH,bar_mod,0)]+((LEVEL+1)*Point);
 if(OrderStopLoss()>Loss_price){Stoploss_modify=OrderModify(OrderTicket(),0,Loss_price,0,0,Orange);if(Stoploss_modify==false){Alert("  o 987:",GetLastError());}}}
 
 }
 
 
 //---------------------------------------------------------------------
 } // if(OrderSelect()......)
 

 }
 
 
 

//----
   return(0);
  }
//+------------------------------------------------------------------+

